#ifndef _EVENTSINK_H_
#define _EVENTSINK_H_

#include <objbase.h>
#include <WbemIdl.h>
#include <initguid.h>

// {236F4029-86BF-406B-AB79-110F80E27DAA}
DEFINE_GUID(CLSID_IMyEventSink, 0x236f4029, 0x86bf, 0x406b, 0xab, 0x79, 0x11, 0xf, 0x80, 0xe2, 0x7d, 0xaa);

// {5DF1A99E-700F-4C99-8CBB-B8AB7417B309}
DEFINE_GUID(IID_IMyEventSink, 0x5df1a99e, 0x700f, 0x4c99, 0x8c, 0xbb, 0xb8, 0xab, 0x74, 0x17, 0xb3, 0x9);


struct IMyEventSinkVtbl_;

typedef struct
{
	struct IMyEventSinkVtbl_ *lpVtbl;
	int						 count;
	char					 buf[80];
} IMyEventSink;

typedef HRESULT(STDMETHODCALLTYPE *QueryInterfacePtr)(IMyEventSink *, REFIID, void **);
typedef ULONG(STDMETHODCALLTYPE *AddRefPtr)(IMyEventSink *);
typedef ULONG(STDMETHODCALLTYPE *ReleasePtr)(IMyEventSink *);
typedef HRESULT(STDMETHODCALLTYPE *IndicatePtr)(IMyEventSink *, LONG lObjectCount, IWbemClassObject **apObjArray);
typedef HRESULT(STDMETHODCALLTYPE *SetStatusPtr)(IMyEventSink *, LONG lFlags, HRESULT hResult, BSTR strParam, IWbemClassObject *pObjParam);

typedef struct IMyEventSinkVtbl_
{
	QueryInterfacePtr QueryInterface;
	AddRefPtr		  AddRef;
	ReleasePtr		  Release;
	IndicatePtr		  Indicate;
	SetStatusPtr      SetStatus;
} IMyEventSinkVtbl;

#endif